//+------------------------------------------------------------------+
//|                                                       BBflat.mq4 |
//|                                                          by Raff |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 13
#property indicator_color1 Salmon
#property indicator_style1 2
#property indicator_color2 Crimson
#property indicator_width2 2
#property indicator_color3 ForestGreen
#property indicator_width3 2
#property indicator_color4 DarkGray
#property indicator_style5 2
#property indicator_width5 1
#property indicator_color5 Teal
#property indicator_style6 2
#property indicator_width6 1
#property indicator_color6 Teal
#property indicator_style7 0
#property indicator_width7 1
#property indicator_color7 DodgerBlue
#property indicator_style8 0
#property indicator_width8 1
#property indicator_color8 DodgerBlue
#property indicator_style9 0
#property indicator_width9 2
#property indicator_color9 LightSkyBlue
#property indicator_style10 0
#property indicator_width10 2
#property indicator_color10 RoyalBlue
#property indicator_style11 0
#property indicator_width11 2
#property indicator_color11 C'255,115,255'
#property indicator_style12 0
#property indicator_width12 2
#property indicator_color12 MediumVioletRed
#property indicator_color13 DarkGray

extern string TimeFrame = "Current time frame";
extern int ma_period           = 20;      //9;
extern int ma_shift            = 0;
extern int ma_method           = 0;
extern int ma_price            = 0;
extern double deviation        = 1.0;     //1.5;
double TrendLine               = 2.0;     //2.2;
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = false;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;
extern bool   Interpolate      = true;

//---- buffers
double Line_ima_Level0[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer1[],cross[];
double TrendLine1[];
double TrendLine2[];
double SidewaysLine1[];
double SidewaysLine2[];
double BB_Up[];
double BB_UpWeak[];
double BB_Dn[];
double BB_DnWeak[];
double BB_Flat[];

int    dL=20000;
int    state=0,stateTf=0;
double BB_Value;
double BB_Value1;
//
//
//
//
//

string indicatorFileName;
bool   returnBars;
int    timeFrame;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(14);
   SetIndexBuffer(0,Line_ima_Level0); //Line_ima_Level0
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer1);
   SetIndexBuffer(4,TrendLine1);
   SetIndexBuffer(5,TrendLine2);
   SetIndexBuffer(6,SidewaysLine1);
   SetIndexBuffer(7,SidewaysLine2);
   SetIndexBuffer(8,BB_Up);
   SetIndexBuffer(9,BB_UpWeak);
   SetIndexBuffer(10,BB_Dn);
   SetIndexBuffer(11,BB_DnWeak);
   SetIndexBuffer(12,BB_Flat);
   SetIndexBuffer(13,cross);
   
   //
   //
   //
   //
   //
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   //
   //
   //
   //
   //

   IndicatorShortName(timeFrameToString(timeFrame)+" BBflat ");
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Line_ima_Level0[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);               
                     
                     BB_Up[i]     = EMPTY_VALUE;
                     BB_UpWeak[i] = EMPTY_VALUE;
                     BB_Dn[i]     = EMPTY_VALUE;
                     BB_DnWeak[i] = EMPTY_VALUE;
                     BB_Flat[i]   = EMPTY_VALUE;

                     Line_ima_Level0[i] = 0;
                     
                     ExtMapBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ma_period,ma_shift,ma_method,ma_price,deviation,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,1,y);
                     ExtMapBuffer3[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ma_period,ma_shift,ma_method,ma_price,deviation,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,2,y);
                     ExtMapBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ma_period,ma_shift,ma_method,ma_price,deviation,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,3,y);
                     
               	   TrendLine1[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendLine,4,y);
               		TrendLine2[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendLine,5,y);
               	   SidewaysLine1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendLine,6,y);
               		SidewaysLine2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendLine,7,y);
                    
                     if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

                     //
                     //
                     //
                     //
                     //
   
                     datetime time = iTime(NULL,timeFrame,y);
                     for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                     for(int x = 1; x < n; x++)
                     {
  	                     ExtMapBuffer2[i+x] = ExtMapBuffer2[i] + (ExtMapBuffer2[i+n] - ExtMapBuffer2[i]) * x/n;
  	                     ExtMapBuffer3[i+x] = ExtMapBuffer3[i] + (ExtMapBuffer3[i+n] - ExtMapBuffer3[i]) * x/n;
  	                     ExtMapBuffer1[i+x] = ExtMapBuffer1[i] + (ExtMapBuffer1[i+n] - ExtMapBuffer1[i]) * x/n;
               	   
                  	   TrendLine1[i+x]    = TrendLine1[i]    + (TrendLine1[i+n]    - TrendLine1[i])    * x/n;
                  		TrendLine2[i+x]    = TrendLine2[i]    + (TrendLine2[i+n]    - TrendLine2[i])    * x/n;
                  	   SidewaysLine1[i+x] = SidewaysLine1[i] + (SidewaysLine1[i+n] - SidewaysLine1[i]) * x/n;
                  		SidewaysLine2[i+x] = SidewaysLine2[i] + (SidewaysLine2[i+n] - SidewaysLine2[i]) * x/n;
                     }
                     
                     //--BB line 5 colors
                     if (ExtMapBuffer1[i]>ExtMapBuffer1[i+1] && Close[i]>Open[i])       state=1;  //up
                     else if (ExtMapBuffer1[i]<ExtMapBuffer1[i+1] && Close[i]<Open[i])  state=2;  //dn
                     else state=0;
               
                     BB_Value     = ExtMapBuffer1[i];
                     BB_Value1    = ExtMapBuffer1[i+1];
                     
                     if ((ExtMapBuffer1[i] > ExtMapBuffer2[i+1]   || ExtMapBuffer1[i] > TrendLine1[i+1]) && ExtMapBuffer1[i] > SidewaysLine1[i+1] && ExtMapBuffer1[i] > ExtMapBuffer2[i+1])        {if (state==2 || state==0) {BB_UpWeak[i] = BB_Value; BB_UpWeak[i+1] = BB_Value1;} if (state==1) {BB_Up[i] = BB_Value; BB_Up[i+1] = BB_Value1;}}
                     if ((ExtMapBuffer1[i] < ExtMapBuffer3[i+1]   || ExtMapBuffer1[i] < TrendLine2[i+1]) && ExtMapBuffer1[i] < SidewaysLine2[i+1] && ExtMapBuffer1[i] < ExtMapBuffer3[i+1])        {if (state==1 || state==0) {BB_DnWeak[i] = BB_Value; BB_DnWeak[i+1] = BB_Value1;} if (state==2) {BB_Dn[i] = BB_Value; BB_Dn[i+1] = BB_Value1;}} 
                     if (!((ExtMapBuffer1[i] > ExtMapBuffer2[i+1] || ExtMapBuffer1[i] > TrendLine1[i+1]) && ExtMapBuffer1[i] > SidewaysLine1[i+1] && ExtMapBuffer1[i] > ExtMapBuffer2[i+1]) 
                           && !((ExtMapBuffer1[i] < ExtMapBuffer3[i+1] || ExtMapBuffer1[i] < TrendLine2[i+1]) && ExtMapBuffer1[i] < SidewaysLine2[i+1] && ExtMapBuffer1[i] < ExtMapBuffer3[i+1]))  {BB_Flat[i] = BB_Value; BB_Flat[i+1] = BB_Value1;}

               }
               return(0);
            }

   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
	   double ima       =  iMA(NULL,0,ma_period,ma_shift,ma_method,ma_price,i);
      double std       =  deviation*iStdDev(NULL,0,ma_period,ma_shift,ma_method,ma_price,i);
      double std_up    =  deviation*iStdDev(NULL,0,ma_period,ma_shift,ma_method,ma_price,i);
      double std_up1   =  deviation*iStdDev(NULL,0,ma_period,ma_shift,ma_method,ma_price,i+1);
      double std_up2   =  deviation*iStdDev(NULL,0,ma_period,ma_shift,ma_method,ma_price,i+2);
      double std_down  = -deviation*iStdDev(NULL,0,ma_period,ma_shift,ma_method,ma_price,i);
      double std_down1 = -deviation*iStdDev(NULL,0,ma_period,ma_shift,ma_method,ma_price,i+1);
      double std_down2 = -deviation*iStdDev(NULL,0,ma_period,ma_shift,ma_method,ma_price,i+2);
      double Line_ima  =  Close[i] - iMA(NULL,0,ma_period,ma_shift,ma_method,ma_price,i);
      double Line_ima1 =  Close[i+1] - iMA(NULL,0,ma_period,ma_shift,ma_method,ma_price,i+1);
      double Line_ima2 =  Close[i+2] - iMA(NULL,0,ma_period,ma_shift,ma_method,ma_price,i+2);

	   double TrendLine_up        =  TrendLine*(High[i]+Low[i])/20000;
	   double TrendLine_up1       =  TrendLine*(High[i+1]+Low[i+1])/20000;
	   double TrendLine_down      = -TrendLine*(High[i]+Low[i])/20000;
	   double TrendLine_down1     = -TrendLine*(High[i+1]+Low[i+1])/20000;
	   
	   dL=20000; //if (Close[i]>1000) dL=4000; if (Close[i]>10000) dL=500;
	   double SidewaysLine_up     =  ( TrendLine*(High[i]+Low[i])/dL)/2;
	   double SidewaysLine_up1    =  ( TrendLine*(High[i+1]+Low[i+1])/dL)/2;
	   double SidewaysLine_down   =  (-TrendLine*(High[i]+Low[i])/dL)/2;
	   double SidewaysLine_down1  =  (-TrendLine*(High[i+1]+Low[i+1])/dL)/2;
	   
		Line_ima_Level0[i] = 0;
      ExtMapBuffer2[i] = std_up;
      ExtMapBuffer3[i] = std_down;
      ExtMapBuffer1[i] = Line_ima;  //Close[i]-ima;
      
	   TrendLine1[i]    = TrendLine_up;
		TrendLine2[i]    = TrendLine_down;
	   SidewaysLine1[i] = SidewaysLine_up;
		SidewaysLine2[i] = SidewaysLine_down;
		
      BB_Up[i]         = EMPTY_VALUE;
      BB_UpWeak[i]     = EMPTY_VALUE;
      BB_Dn[i]         = EMPTY_VALUE;
      BB_DnWeak[i]     = EMPTY_VALUE;
      BB_Flat[i]       = EMPTY_VALUE;

      //--BB line 5 colors
      if (ExtMapBuffer1[i]>ExtMapBuffer1[i+1] && Close[i]>Open[i])       state=1;  //up
      else if (ExtMapBuffer1[i]<ExtMapBuffer1[i+1] && Close[i]<Open[i])  state=2;  //dn
      else state=0;

      BB_Value     = ExtMapBuffer1[i];
      BB_Value1    = ExtMapBuffer1[i+1];
      
      if ((ExtMapBuffer1[i] > ExtMapBuffer2[i+1]   || ExtMapBuffer1[i] > TrendLine1[i+1]) && ExtMapBuffer1[i] > SidewaysLine1[i+1] && ExtMapBuffer1[i] > ExtMapBuffer2[i+1])        {if (state==2 || state==0) {BB_UpWeak[i] = BB_Value; BB_UpWeak[i+1] = BB_Value1;} if (state==1) {BB_Up[i] = BB_Value; BB_Up[i+1] = BB_Value1;}}
      if ((ExtMapBuffer1[i] < ExtMapBuffer3[i+1]   || ExtMapBuffer1[i] < TrendLine2[i+1]) && ExtMapBuffer1[i] < SidewaysLine2[i+1] && ExtMapBuffer1[i] < ExtMapBuffer3[i+1])        {if (state==1 || state==0) {BB_DnWeak[i] = BB_Value; BB_DnWeak[i+1] = BB_Value1;} if (state==2) {BB_Dn[i] = BB_Value; BB_Dn[i+1] = BB_Value1;}} 
      if (!((ExtMapBuffer1[i] > ExtMapBuffer2[i+1] || ExtMapBuffer1[i] > TrendLine1[i+1]) && ExtMapBuffer1[i] > SidewaysLine1[i+1] && ExtMapBuffer1[i] > ExtMapBuffer2[i+1]) 
            && !((ExtMapBuffer1[i] < ExtMapBuffer3[i+1] || ExtMapBuffer1[i] < TrendLine2[i+1]) && ExtMapBuffer1[i] < SidewaysLine2[i+1] && ExtMapBuffer1[i] < ExtMapBuffer3[i+1]))  {BB_Flat[i] = BB_Value; BB_Flat[i+1] = BB_Value1;}
      
      cross[i] = 0;
         if (ExtMapBuffer1[i]>ExtMapBuffer2[i]) cross[i] =  1;
         if (ExtMapBuffer1[i]<ExtMapBuffer3[i]) cross[i] = -1;
	   
   }
   manageAlerts();
//----
   return(0);
  }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (cross[whichBar] != cross[whichBar+1])
      {
         if (cross[whichBar] ==  1) doAlert(whichBar,"up");
         if (cross[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(Period())," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," bbflat crossed deviation ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," bbflat "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}